/***************************************************************************
 *   Copyright (C) 2007 by Dr. Feynman                                     *
 *   dr@feynman.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdlib.h>

#include "feynman.h"

t_feynman_sid *feynman_add_sid(t_feynman_card *card, unsigned short new_sid, char mode)
{
    if(card == NULL) return NULL;

    t_feynman_sid *sid = feynman_get_sid(card, new_sid);
    if(sid)
    {
        sid->mode = mode;
        return sid;
    }

    sid = (t_feynman_sid *)malloc(sizeof(t_feynman_sid));
    sid->sid = new_sid;
    sid->mode = mode;
    sid->card_id = card->card_id;
    sid->next = card->sid_db;

    card->sid_db = sid;

    return sid;
}

void feynman_del_sid(t_feynman_card *card, t_feynman_sid *sid_to_del)
{
    if(card == NULL) return;
	if(sid_to_del == NULL) return;
	
    t_feynman_sid *sid = card->sid_db;
    t_feynman_sid *prev = card->sid_db;
    while(sid != NULL)
    {
        t_feynman_sid *tmp_sid = sid->next;
        if(sid_to_del == sid)
        {
            if(prev != NULL)
            {
                prev->next = sid->next;
            }
            if(card->sid_db == sid)
            {
                card->sid_db = sid->next;
            }
            free(sid);
            return;
        }
        prev = sid;
        sid = tmp_sid;
    }
}

void feynman_del_sids(t_feynman_card *card)
{
    if(card == NULL) return;
	
    t_feynman_sid *sid = card->sid_db;
    t_feynman_sid *prev = card->sid_db;
    while(sid != NULL)
    {
        t_feynman_sid *tmp_sid = sid->next;
        if(1)
        {
            if(prev != NULL)
            {
                prev->next = sid->next;
            }
            if(card->sid_db == sid)
            {
                card->sid_db = sid->next;
            }
            free(sid);
        }
        prev = sid;
        sid = tmp_sid;
    }
}

t_feynman_sid *feynman_get_sid(t_feynman_card *card, unsigned short service_id)
{
    if(!card) return NULL;

    t_feynman_sid *sid;
    for(sid=card->sid_db; sid!=NULL; sid=sid->next)
    {
        if(sid->sid == service_id)
        {
            return sid;
        }
    }
    return NULL;
}
